//---------------------------------------------------------------------------
extern struct CPU_Regs cpu;
//---------------------------------------------------------------------------
//extern char CPU_emul(struct CPU_Regs cpu);

extern void CIA_emul();
extern void VIC_emul();

extern void CIA_Reset();
extern void VIC_Reset();
extern void SID_Reset();
extern void CPU_Reset();

extern void C64_Reset();

extern void SID_Create();
extern unsigned int SID_calc_buffer();

extern void VIC_Recalcdatas();
//---------------------------------------------------------------------------
static int start_pc=-1;
static int init_breakpoint=-1;
//---------------------------------------------------------------------------
static char emulation_run=0;
//---------------------------------------------------------------------------
//- Debugging datas ---------------------------------------------------------
//---------------------------------------------------------------------------
static char opcodes[256][4]={
"brk\0","ora\0","???\0","???\0","???\0","ora\0","asl\0","???\0","php\0","ora\0","asl\0","???\0","NOP\0","ora\0","asl\0","???\0", // 0x00
"bpl\0","ora\0","???\0","???\0","???\0","ora\0","asl\0","???\0","clc\0","ora\0","NOP\0","???\0","NOP\0","ora\0","asl\0","???\0", // 0x10
"jsr\0","and\0","???\0","???\0","bit\0","and\0","rol\0","???\0","plp\0","and\0","rol\0","???\0","bit\0","and\0","rol\0","???\0", // 0x20
"bmi\0","and\0","???\0","???\0","???\0","and\0","rol\0","???\0","sec\0","and\0","NOP\0","???\0","NOP\0","and\0","rol\0","???\0", // 0x30
"rti\0","eor\0","???\0","???\0","???\0","eor\0","lsr\0","???\0","pha\0","eor\0","lsr\0","???\0","jmp\0","eor\0","lsr\0","???\0", // 0x40
"bvc\0","eor\0","???\0","???\0","???\0","eor\0","lsr\0","???\0","cli\0","eor\0","NOP\0","???\0","NOP\0","eor\0","lsr\0","???\0", // 0x50
"rts\0","adc\0","???\0","???\0","???\0","adc\0","ror\0","???\0","pla\0","adc\0","ror\0","???\0","jmp\0","adc\0","ror\0","???\0", // 0x60
"bvs\0","adc\0","???\0","???\0","???\0","adc\0","ror\0","???\0","sei\0","adc\0","NOP\0","???\0","NOP\0","adc\0","ror\0","???\0", // 0x70
"???\0","sta\0","???\0","???\0","sty\0","sta\0","stx\0","???\0","dey\0","???\0","txa\0","???\0","sty\0","sta\0","stx\0","AXS\0", // 0x80
"bcc\0","sta\0","???\0","???\0","sty\0","sta\0","stx\0","???\0","tya\0","sta\0","txs\0","???\0","???\0","sta\0","???\0","???\0", // 0x90
"ldy\0","lda\0","ldx\0","LDT\0","ldy\0","lda\0","ldx\0","LDT\0","tay\0","lda\0","tax\0","???\0","ldy\0","lda\0","ldx\0","LDT\0", // 0xa0
"bcs\0","lda\0","???\0","LDT\0","ldy\0","lda\0","ldx\0","LDT\0","clv\0","lda\0","tsx\0","???\0","ldy\0","lda\0","ldx\0","LDT\0", // 0xb0
"cpy\0","cmp\0","???\0","???\0","cpy\0","cmp\0","dec\0","DCP\0","iny\0","cmp\0","dex\0","???\0","cpy\0","cmp\0","dec\0","DCP\0", // 0xc0
"bne\0","cmp\0","???\0","???\0","???\0","cmp\0","dec\0","???\0","cld\0","cmp\0","NOP\0","???\0","NOP\0","cmp\0","dec\0","???\0", // 0xd0
"cpx\0","sbc\0","???\0","???\0","cpx\0","sbc\0","inc\0","???\0","inx\0","sbc\0","nop\0","???\0","cpx\0","sbc\0","inc\0","???\0", // 0xe0
"beq\0","sbc\0","???\0","ISB\0","???\0","sbc\0","inc\0","???\0","sed\0","sbc\0","NOP\0","???\0","NOP\0","sbc\0","inc\0","???\0"};

static char codesizetable[256]={
  1,2,1,1,1,2,2,1,1,2,1,1,3,3,3,1,      // 0x00
  2,2,1,1,1,2,2,1,1,3,1,1,3,3,3,1,      // 0x10
  3,2,1,1,2,2,2,1,1,2,1,1,3,3,3,1,      // 0x20
  2,2,1,1,1,2,2,1,1,3,1,1,3,3,3,1,      // 0x30
  1,2,1,1,1,2,2,1,1,2,1,1,3,3,3,1,      // 0x40
  2,2,1,1,1,2,2,1,1,3,1,1,3,3,3,1,      // 0x50
  1,2,1,1,1,2,2,1,1,2,1,1,3,3,3,1,      // 0x60
  2,2,1,1,1,2,2,1,1,3,1,1,3,3,3,1,      // 0x70
  1,2,1,1,2,2,2,1,1,1,1,1,3,3,3,3,      // 0x80
  2,2,1,1,2,2,2,1,1,3,1,1,1,3,1,1,      // 0x90
  2,2,2,2,2,2,2,2,1,2,1,1,3,3,3,3,      // 0xa0
  2,2,1,2,2,2,2,2,1,3,1,1,3,3,3,3,      // 0xb0
  2,2,1,1,2,2,2,2,1,2,1,1,3,3,3,3,      // 0xc0
  2,2,1,1,1,2,2,1,1,3,1,1,3,3,3,1,      // 0xd0
  2,2,1,1,2,2,2,1,1,2,1,1,3,3,3,1,      // 0xe0
  2,2,1,3,1,2,2,1,1,3,1,1,3,3,3,1};


/* 0 - nothin'
   1 - ix  ($xx,x)
   2 - np  $xx
   3 - abs $xxyy
   4 - iy  ($xx),y
   5 - npx $xx,x
   6 - aby $xxyy,y
   7 - abx $xxyy,x
   8 - rel +-127
   9 - ind ($xxyy)
  10 - npy $xx,y
  11 - dir #$xx
  12 - ajm $xxxx */

static char addrmode[256]={
   0,1, 0, 0,0,2, 2, 0,0,11,0,0, 3,3,3,0,	  // 0x00
   8,4, 0, 0,0,5, 5, 0,0, 6,0,0, 3,7,7,0,         // 0x10
  12,1, 0, 0,2,2, 2, 0,0,11,0,0, 3,3,3,0,         // 0x20
   8,4, 0, 0,0,5, 5, 0,0, 6,0,0, 3,7,7,0,         // 0x30
   0,1, 0, 0,0,2, 2, 0,0,11,0,0,12,3,3,0,         // 0x40
   8,4, 0, 0,0,5, 5, 0,0, 6,0,0, 3,7,7,0,         // 0x50
   0,1, 0, 0,0,2, 2, 0,0,11,0,0, 9,3,3,0,         // 0x60
   8,4, 0, 0,0,5, 5, 0,0, 6,0,0, 3,7,7,0,         // 0x70
   0,1, 0, 0,2,2, 2, 0,0, 0,0,0, 3,3,3,3,         // 0x80
   8,4, 0, 0,5,5,10, 0,0, 6,0,0, 0,7,0,0,         // 0x90
  11,1,11, 1,2,2, 2, 2,0,11,0,0, 3,3,3,3,         // 0xa0
   8,4, 0, 4,5,5,10,10,0, 6,0,0, 7,7,6,6,	  // 0xb0
  11,1, 0, 0,2,2, 2, 2,0,11,0,0, 3,3,3,3,	  // 0xc0
   8,4, 0, 0,0,5, 5, 0,0, 6,0,0, 3,7,7,0,	  // 0xd0
  11,1, 0, 0,2,2, 2, 0,0,11,0,0, 3,3,3,0,	  // 0xe0
   8,4, 0, 0,0,5, 5, 0,0, 6,0,0, 3,7,7,0};	  // 0xf0

static unsigned char keycodes_normal[256]={
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x14, 0x00, 0x00, 0x00, 0x00, 0x0d, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x20, 0x00, 0x00, 0x00, 0x13, 0x9d, 0x91, 0x1d, 0x11, 0x00, 0x00, 0x00, 0x00, 0x00, 0x5e, 0x00,
 0x30, 0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x37, 0x38, 0x39, 0x00, 0x3b, 0x00, 0x3d, 0x00, 0x00,
 0x00, 0x41, 0x42, 0x43, 0x44, 0x45, 0x46, 0x47, 0x48, 0x49, 0x4a, 0x4b, 0x4c, 0x4d, 0x4e, 0x4f,
 0x50, 0x51, 0x52, 0x53, 0x54, 0x55, 0x56, 0x57, 0x58, 0x59, 0x5a, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3a, 0x2d, 0x2c, 0x2b, 0x2e, 0x2f,
 0x5f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x40, 0x3d, 0x2a, 0x3b, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};

static unsigned char keycodes_shifted[256]={
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x94, 0x00, 0x00, 0x00, 0x00, 0x8d, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x20, 0x00, 0x00, 0x00, 0x93, 0x9d, 0x91, 0x1d, 0x11, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7e, 0x00,
 0x00, 0x21, 0x22, 0x23, 0x24, 0x25, 0x26, 0x27, 0x28, 0x29, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x61, 0x62, 0x63, 0x64, 0x65, 0x66, 0x67, 0x68, 0x69, 0x6a, 0x6b, 0x6c, 0x6d, 0x6e, 0x6f,
 0x70, 0x71, 0x72, 0x73, 0x74, 0x75, 0x76, 0x77, 0x78, 0x79, 0x7a, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x5b, 0x7d, 0x3c, 0x7b, 0x3e, 0x3f,
 0x5f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3d, 0x60, 0x5d, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};

static unsigned char keyb_rowcol[256]={
 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x72, 0xff, 0xff, 0xff, 0x01, 0xff, 0xff,
 0x17, 0x75, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x77, 0xff, 0xff, 0xff, 0xff,
 0x74, 0xff, 0xff, 0xff, 0x63, 0x02, 0x07, 0x02, 0x07, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
 0x43, 0x70, 0x73, 0x10, 0x13, 0x20, 0x23, 0x30, 0x33, 0x40, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
 0xff, 0x12, 0x34, 0x24, 0x22, 0x16, 0x25, 0x32, 0x35, 0x41, 0x42, 0x45, 0x52, 0x44, 0x47, 0x46,
 0x51, 0x76, 0x21, 0x15, 0x26, 0x36, 0x37, 0x11, 0x27, 0x31, 0x14, 0xff, 0xff, 0xff, 0xff, 0xff,
 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
 0x04, 0x04, 0x05, 0x05, 0x06, 0x06, 0x03, 0x03, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x55, 0x53, 0x57, 0x50, 0x54, 0x67,
 0x71, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x56, 0x65, 0x61, 0x62, 0xff,
 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff};

//---------------------------------------------------------------------------
